diff --git a/kernel/sched.c b/kernel/sched.c
index 49b78b4a995f..957da7a3c635 100644
--- a/kernel/sched.c
+++ b/kernel/sched.c
@@ -482,9 +482,11 @@ void z_thread_priority_set(struct k_thread *thread, int prio)
 		need_sched = z_is_thread_ready(thread);
 
 		if (need_sched) {
-			_priq_run_remove(&_kernel.ready_q.runq, thread);
 			thread->base.prio = prio;
-			_priq_run_add(&_kernel.ready_q.runq, thread);
+			if (z_is_thread_queued(thread)) {
+				_priq_run_remove(&_kernel.ready_q.runq, thread);
+				_priq_run_add(&_kernel.ready_q.runq, thread);
+			}
 			update_cache(1);
 		} else {
 			thread->base.prio = prio;
